#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <time.h>
#define CTE  2.506631   //CTE=sqrt(2.0*PI)

 double ** test(double **X,int min,int n,int p){
          double **temp;
          int i,j;
          temp=calloc(n,sizeof(double *));//se asigna memoria dinamica para la matriz de salida
          for(i=0;i<n;i++)
              temp[i]= X[i+min];         //se asigna al vector de salida las filas correspondientes  de  X
          return temp;
          }

/* funcion que dado una matriz X, obtiene una muestra de las filas de X distintas de  las filas  que   *
 * se uso para test, se debe ingresar un entero  minimo, maximo, # de filas de la  division  y el # de *
 * columnas de la matriz                       				                               */

double ** training(double **X,int min,int max,int n,int p){
          double **temp;
          int i,j;
          temp=calloc(n,sizeof(double *));   
          for(i=0;i<min;i++)
                temp[i]= X[i];               
          for(i=min;i<n-(max-min);i++)
                temp[i]= X[i+max-min];      
           return temp;
         }

/*funcion que genera numeros aleatorios desde cero hasta n*/

int * randperm(int n ){
       int i,j,min;
       int * a=NULL;
       int * indice=NULL;
       indice=(int *)calloc(n,sizeof(int)); 
       a=(int *)calloc(n,sizeof(int));      
       srand(time(NULL));                   
       for(i=0;i<n;i++)
           a[i]=rand()%n;                   
       for ( i = 0; i < n;i++ ){
           min=i;
           for (j = 0; j < n; j++ )
                if ( a[j] < a[min] ) {
                    min=j;
                }
           a[min]=n;
           indice[i]=min;                   
       }
       return indice;
       }

/*funcion que calcula el kernel gaussiano*/

double kernel(double x){
       return 1.0/(exp((x*x)/2.0)*CTE);   // CTE = sqrt(2.0*PI);
       }

/*funcion que calcula el vector  del ancho de banda para una clase X, se debe ingresar el # de filas de la clase asi como  el # de columanas*/

double * banda(double **trai, int **clases,int n_trai,int j,int p){
       double s,d, Xmean;
       double *h=NULL;
       int i,v;
       h=calloc(p,sizeof(double));          

       for(v=0;v<p ;v++){
	 Xmean=0;
	 d=0;
	 s=0;
	 for(i=0;i<n_trai;i++){
	   s+=trai[clases[j][i]][v];
	 }
	 Xmean =s/n_trai;                   
	 for(i=0;i<n_trai;i++){
	   d+=(trai[clases[j][i]][v]-Xmean)*(trai[clases[j][i]][v]-Xmean);
	 }
	 d=sqrt(d/(n_trai-1));                          //para cada columna se calcula la desviacion estandar
	 
	 h[v]=d*(pow(4.0,1.0/(double)(p+4))/pow((double)((p+2)*n_trai),1.0/(double)(p+4)));
       }
       return h;
       }


double * kernel_usual(double **x,double *h,double **trai, int **clases,int n_trai,int c,int n, int p,int N){
       int v,j,i;
       double s=0.0,t,H=1.0,k;
       double *f=NULL;
       double pro=(double)n_trai/(double)(N-n);
       f=calloc(n,sizeof(double));
       for(v=0;v<p;v++)
                   H=H*h[v];   
       H=H*(double)n_trai;
       for (i=0;i<n;i++){
	 s=0.0;
	 for(j=0;j<n_trai ;j++){
	   k=1.0;
	   for(v=0;v<p;v++){
	     t=kernel((x[i][v]-trai[clases[c][j]][v])/h[v]);
	     k=k*t;
	   }
	   s=s+k;                         //para acumular las productorias y asi obtener la sumatoria.
	 }
	 f[i]=pro*(s/H);   //se almacena los estimados para cada fila del test
       }
       return f;
       }


 int error(double **f,int * k_indices ,int n,int m,int min ){
      int i,j,e=0,k;
      double max;
       for(j=0;j<n;j++){
             max=0;
             for(i=0;i<m;i++){
                   if(f[i][j]>=max){
                        max=f[i][j];
                        k=i+1;
                    }
             }
	     if(k_indices[j+min]!=k){
                 e++;
	
	     }

       }
       return e;
       }


double **estimado_kernel_usual(double ** x, double ** X,int ntrai, int p,int m,int r,int N){
       double **f;
       double ** temp;
       double *h=NULL;
       int *n_trai=NULL;       
       int **clases;
       int i,j,cont;

       n_trai=calloc(m+1,sizeof(int));
       clases =calloc(m+1,sizeof(int *));
       f=calloc(m,sizeof(double *)); //se asigna memoria dinamica para la matriz de estimados
       h=calloc(p,sizeof(double));   //se asigna memoria dinamica para el vector del ancho de banda
       for(j=0;j<=m;j++){
	 n_trai[j]=0; 
	 clases[j]=calloc(n,sizeof(int));   
       }  
       for(i=0;i<ntrai;i++){
	 clases[(int)X[i][p-1]][n_trai[(int)X[i][p-1]]++]=i;
       }
       for(j=0;j<m;j++){
            h=banda(X,clases,n_trai[j+1],j+1,p-1); 
            f[j] = kernel_usual(x,h,X,clases,n_trai[j+1],j+1,r,p-1,N);
      }
      return f;
}

/*funcion que calcula los errore al clasificar,por crossvalidacion cruzada # 10, se debe ingresar el vector de los datos originales(x) *
 * el # de filas(n),  el # de clases(m) y el # de columnas (p)								               */
int cross(double * x,int n,int m,int p){
    int i,j,r,e=0,err=0;
    int *a=NULL;
    int *indice=NULL;

    double **f;
    double **tes;
    double **X;
    double **trai;
    int *k=NULL;

    X=malloc(n*sizeof(double *)); //se asigna memoria dinamica para la matriz original
    tes=malloc(n*sizeof(double *)); //se asigna memoria dinamica para la matriz de test
    trai=malloc(n*sizeof(double *)); //se asigna memoria dinamica para la matriz de training
    k=calloc(n,sizeof(int));        //se asigna memoria dinamica para el vector de indices
    indice=(int *)calloc(n,sizeof(int)); //se asigna memoria dinamica para el vector de indices permutados

    indice=randperm(n);  //se llama a la funcion randperm para para obtener los indices permutados
    for(i=0;i<n;i++){
          X[i]=x+indice[i]*p; //se hace una copia del vector x a la matriz X
          k[i]=X[i][p-1];     // se almacena los valores de la ultima columna de X
    }

    r=n/10;
    j=0;
    if(n%10==0){      //en el caso en que el # de filas sea divisible por 10
          for(i=0;i<10;i++){
             j=j+r;
             trai=training(X,j-r,j,n,p);            //se llama a la funcion training para obtener la matriz trai
             tes=test(X,j-r,r,p);                   //se llama a la funcion test para obtener la matriz tes
             f=estimado_kernel_usual(tes,trai,n-r,p,m,r,n);     //se calcula la matriz de estimados
             e=error(f,k,r,m,j-r);                  //se llama a la funcion error para obtener los errores
             err+=e; 
	   
          }
     }
     else {        //en el caso en que el # de filas no sea divisible  por 10
           for(i=0;i<n%10;i++){
              j=j+r+1;
              trai=training(X,j-r-1,j,n,p);       //se llama a la funcion training para obtener la matriz trai
              tes=test(X,j-r-1,r+1,p);            //se llama a la funcion test para obtener la matriz tes
              f=estimado_kernel_usual(tes,trai,n-(r+1),p,m,r+1,n);   //se calcula la matriz de estimados
              e=error(f,k,r+1,m,j-r-1);          //se llama a la funcion error para obtener los errores
              err+=e; 
	     
           }
           for(i=n%10;i<10;i++){
               j=j+r;
               trai=training(X,j-r,j,n,p);        //se llama a la funcion training para obtener la matriz trai
               tes=test(X,j-r,r,p);               //se llama a la funcion test para obtener la matriz tes
              f=estimado_kernel_usual(tes,trai,n-r,p,m,r,n);  //se calcula la matriz de estimados
              e=error(f,k,r,m,j-r);               //se llama a la funcion error para obtener los errores
              err+=e;
	    
           }
     }
     return err;
     }

/* funcion main, se debe ingresar en la linea de comandos lo siguiente:  argv [1] la matriz original;  argv [2] el numero de filas, *
 * argv [3] el numero de columnas; argv [4] el numero de clases y argv [5] el # de veces para promediar                             */


int main(int argc, char * argv[]){

    FILE *in;                //se declara un apuntador de tipo FILE
    int i,j=0,promedio;
    double *x=NULL;    //se declara apuntador de tipo double para leer los datos del archivo
    int n,m,p;
    int cont;
    int err=0,e=0;
    clock_t  now, later;
    long passed;
    now = clock(); 


    if(argc!=6){
       fprintf(stderr,"Uso de %s\n  nombre_del_archivo #_de_filas  #_de_columnas #_de_clases #_de_corridas_promedio\n",argv[0]);
       exit(1);
    }


    n=atoi(argv[2]);            //se convierte el segundo argumento a tipo entero
    p=atoi(argv[3]);            //se convierte el tercer argumento a tipo entero
    m=atoi(argv[4]);            //se convierte el cuarto argumento a tipo entero
    promedio = atoi(argv[5]);   //se convierte el quinto argumento a tipo entero
    x=calloc(n*p,sizeof(double));    //se asiga memoria dinamicamente para el vector donde se va leer
    in=fopen(argv[1],"r");        //se abre el archivo del primer argumento solo para lectura
    if(in==NULL){                 //si no se pudo abrir entonces se da un mensaje de error y el programa finaliza
         printf("problemas con el archivo de salida");
         exit(1);
    }
    while (!feof(in)){  
      fscanf(in,"%lf",&x[j]);  
      j++;
    }
    fclose(in); 
    for(i=0;i<promedio;i++){
      e=cross(x,n,m,p);    
      err+=e;
    }
    later = clock();
    passed =  later - now;
    printf("\nPROGRAMA %s DATA %s ERROR %f TIEMPO  %f\n ",argv[0],argv[1],(double)(err)/(double)(n*promedio),(float)passed/(float)(promedio*1000000));
  

   return 0;
 }
