#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#define PI 3.1416
#define MAX 10000

double kernel(double x){
return exp(-(x*x/2))/sqrt(2*PI);
}

double suma(double * X,int n, double t, double h ){
double s=0;
int i;
for(i=0;i<n ;i++)
s+=kernel((t-X[i])/h);
return s;
}

double f_estimado(double h ,double t,int n,double * K){
double s;
s = suma(K,n,t,h);
return  s/(n*h);
}


void leerX(double * X,int n){
int i;
for(i=1;i<=n ;i++)
scanf("%lf",&X[i]);
printf("\n");
}

double des_est(double *X, int n){
double s=0,d=0, Xmean;
int i;

for(i=0;i<n ;i++)
s+=X[i];
Xmean =s/n;
printf("MEAN %lf \n",Xmean);

for(i=0;i<n ;i++)
d+=(X[i]-Xmean)*(X[i]-Xmean);
d=sqrt(d/(n-1));
return d;
}

void AdjustH(double a[],int i, int n)
{

int j,item;
 j = 2*i;
 item = a[i];
       while (j <= n) {
          if ((j<n) && (a[j]<a[j+1])) j++;
             // Compare left and right child
             // and let j be the larger child.
          if (item >= a[j]) break;
             // A position for item is found.
          a[j/2] = a[j]; j *= 2;
       }
       a[j/2] = item;
   }


void Heapify(double a[],int n)
   // Readjust the elements in a[1:n] to form a heap.
   {
   int i;
    //double a[SIZE];
   for ( i=n/2; i; i--)
   AdjustH(a, i, n);
   }

void HeapSort(double a[], int n)
   // a[1:n] contains n elements to be sorted. HeapSort
   // rearranges them in-place into nondecreasing order.
   {
       int i;
       Heapify(a, n); // Transform the array into a heap.
       // Interchange the new maximum with the element
       // at the end of the array.
       for (i=n; i>=2; i--) {
          int t = a[i];
           a[i] = a[1]; a[1]=t;
          AdjustH(a, 1, i-1);
       }
   }





int main(int argc , char *argv[]){
FILE *in,*out;
double *X=NULL,*t=NULL,*f=NULL,h,d,a;
int n=0,i;

in = fopen(argv[1],"r");
if(in==NULL){
printf("problemas con el archivo de salida ");
exit(1);
}

X=malloc(MAX*sizeof(double));
t=malloc(MAX*sizeof(double));
f=malloc(MAX*sizeof(double));
while (!feof(in)){
n++;
fscanf(in,"%lf",&X[n]);
}

fclose(in);
n=n-1;

HeapSort(X,n);
for (i = 0; i <n;i++)
printf("%lf \n",X[i+1]);

a=(X[n]-X[1])/n;

for (i = 1; i <=n;i++){
X[i-1]=X[i];
t[i-1]=X[0]+a*i;
}
d=des_est(X,n);
h=1.06*d*pow(n,-0.2);

out = fopen(argv[2],"w");
if(out==NULL){
printf("no hay suficiente memoria ");
exit(1);
}
for (i = 0; i <n;i++){
f[i]=f_estimado(h,t[i],n,X);
//printf("%lf \t %lf \n",t[i],f[i]);
fprintf(out,"%lf \t %lf \n",t[i],f[i]);
}

printf("desviacion estandar = %lf",d);
fclose(out);
free(X);
free(t);
free(f);
return 0;
}
