#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <time.h>
#include "mpi.h"
#define CTE  2.506631   /*CTE=sqrt(2.0*PI)*/

void print(double **X,int n,int m){
       int i,j;
        for(i=0;i<n;i++){
                for(j=0;j<m;j++)
                      printf("%e\t",X[i][j]);
                 printf("\n");
           }

       }
void print2(double *X,int n,int m){
       int i,j;
        for(i=0;i<n;i++){
                for(j=0;j<m;j++)
                      printf("%lf\t",*(X+m*i+j));
                 printf("\n");
           }

       }

 double ** test(double **X,int min,int n,int p){
          double **temp;
          int i,j;
          temp=calloc(n,sizeof(double *));/*se asigna memoria dinamica para la matriz de salida*/
          for(i=0;i<n;i++)
              temp[i]= X[i+min];         /*se asigna al vector de salida las filas correspondientes  de  X*/
          return temp;
          }

double ** training(double **X,int min,int max,int n,int p){
          double **temp;
          int i,j;
          temp=calloc(n,sizeof(double *));   /*se asigna memoria dinamica para la matriz de salida*/
          for(i=0;i<min;i++)
                temp[i]= X[i];               /*se asigna al vector de salida las filas de X desede 0 hasta un minimo */
          for(i=min;i<n-(max-min);i++)
                temp[i]= X[i+max-min];      /*se asigna al vector de salida las filas de X desde un maximo hasta N */
           return temp;
         }

/*funcion que genera numeros aleatorios desde cero hasta n*/

int * randperm(int n ){
       int i,j,min;
       int * a=NULL;
       int * indice=NULL;
       indice=(int *)calloc(n,sizeof(int));    /*se asigna memoria dinamica para el vector de salida */
       a=(int *)calloc(n,sizeof(int));         /*se asigna memoria dinamica para el vector temporal de #s aleatorios */
       srand(time(NULL));                      /*generador de los #s aleatorios utilizando el tiempo como semilla */
       for(i=0;i<n;i++)
           a[i]=rand()%n;                     /*se almacena #s aleatorios de 0 hasta n */
       for ( i = 0; i < n;i++ ){
           min=i;
           for (j = 0; j < n; j++ )
                if ( a[j] < a[min] ) {
                    min=j;
                }
           a[min]=n;
           indice[i]=min;                   /*se almacena en el vector de salida los indices de los #s aleatorios de menor a mayor*/
       }
       return indice;
       }

/*funcion que calcula el kernel gaussiano*/

double kernel(double x){
       return 1.0/(exp((x*x)/2.0)*CTE);   /* CTE = sqrt(2.0*PI);*/
       }

/*funcion que calcula el vector  del ancho de banda para una clase X, se debe ingresar el # de filas de la clase asi como  el # de columanas*/

double * banda(double **X, int n,int p){
       double s,d, Xmean;
       double *h=NULL;
       int i,v;
       h=calloc(n,sizeof(double));                    /*se asigna memoria dinamica para el vector de salida*/
       for(v=0;v<p ;v++){
            Xmean=0;
            d=0;
            s=0;
            for(i=0;i<n;i++){
                 s+=X[i][v];
            }
            Xmean =s/n;                               /*para cada columna se calcula la media por filas*/
            for(i=0;i<n;i++){
                d+=(X[i][v]-Xmean)*(X[i][v]-Xmean);
            }
            d=sqrt(d/(n-1));                          /*para cada columna se calcula la desviacion estandar*/

            h[v]=d*(pow(4.0,1.0/(double)(p+4))/pow((double)((p+2)*n),1.0/(double)(p+4)));

       }
       return h;
       }

 double suma_productoria(double **x,double *h, double **X,int i, int p,int m ){
        double s=0.0,k,t=0.0;
        int j,v;
        for(j=0;j<m ;j++){
                k=1.0;
                for(v=0;v<p;v++){
                     t=kernel((x[i][v]-X[j][v])/h[v]);
                     k=k*t;
                }
              s=s+k;                         /*para acumular las productorias y asi obtener la sumatoria.*/
        }
        return s;
        }

double *estimado(double **x,double *h,double **X,int n_cross, int p,int m_elem,int N,int rank ,int size){
       int v,j,i,residuo=n_cross-size*(n_cross/size),q=n_cross/size;
       double t,k,s=0.0,H=1.0;
       double *f=NULL;
       double pro=(double)m_elem/(double)(N-n_cross);

      
       for(v=0;v<p;v++)
                   H=H*h[v];   /*se calcula la productoria de los elemantos del ancho de  banda*/
       H=H*(double)m_elem;
        
       if(rank<residuo){

           f=calloc(q+1,sizeof(double));/*se asigna memoria dinamica para el vector de salida*/
           for (i=rank*(q+1);i<(rank+1)*(q+1);i++){

              s=0.0;                   
              for(j=0;j<m_elem ;j++){
                k=1.0;
                for(v=0;v<p;v++){
                     t=kernel((x[i][v]-X[j][v])/h[v]);
                     k=k*t;
                }
              s=s+k;                         /*para acumular las productorias y asi obtener la sumatoria.*/
               }
      
             f[i-rank*(q+1)]=pro*(s/H);   /*se almacena los estimados para cada fila del test*/
           }
       }

       else {
           
           f=calloc(q,sizeof(double));
           for (i=residuo+rank*q;i<residuo+(rank+1)*q;i++){

              s=0.0;                   
              for(j=0;j<m_elem ;j++){
                k=1.0;
                for(v=0;v<p;v++){
                     t=kernel((x[i][v]-X[j][v])/h[v]);
                     k=k*t;
                }
              s=s+k;                         /*para acumular las productorias y asi obtener la sumatoria.*/
               }
      
             f[i-(residuo+rank*q)]=pro*(s/H);   /*se almacena los estimados para cada fila del test*/
           }
       

      }

     return f;
    }




int errores(double **x, double **X,int *k_indices,int n, int p,int m,int n_cross,int j_val,int rank,int size){
 
       int i,j,v,cont,n_trai=n-n_cross,min=j_val-n_cross;
       int  error(double **,int *,int,int,int,int ,int);
       double peso,s,k,t,e,H;
       double **f;
       double **temp;
       double *h=NULL;
       
       h=calloc(p,sizeof(double));
       f=calloc(m,sizeof(double *)); 
       temp=calloc(n_trai,sizeof(double *));
       
       for(j=0;j<m;j++){
            cont=0;
            for(i=0;i<n_trai;i++)
                    if(X[i][p-1]==(double)(j+1)){
                       temp[cont++]= X[i];           
                    }

            h=banda(temp,cont,p-1);                  
            peso=(double)cont/(double)(n-n_cross);
	
	    f[j]=estimado(x,h,temp,n_cross,p-1,cont,n,rank,size);
 
       }
      e=error(f,k_indices,n_cross,m,min,rank,size);
      return e;

}





 int error(double **f,int * k_indices ,int n_cross,int m,int min ,int rank,int size){
      int i,j,e=0,k,q=n_cross/size,residuo=n_cross-size*(n_cross/size);
      double max;

      if(rank<residuo){
    
          for(j=0;j<q+1;j++){
             max=0;
             for(i=0;i<m;i++){
                   if(f[i][j]>=max){
                        max=f[i][j];
                        k=i+1;
                    }
             }
            
             if(k_indices[j+min+rank*(q+1)]!=k) 
                 e++;

          }

      }

      else {
             for(j=0;j<q;j++){
             max=0;
                for(i=0;i<m;i++){
                   if(f[i][j]>=max){
                        max=f[i][j];
                        k=i+1;
                    }
                 }
            
                 if(k_indices[j+min+residuo+rank*q]!=k) 
                     e++;

           }
     
      }

    return e;
    }


/*

int cross(double * x,int n,int m,int p){
    int i,j,r,e=0,err=0,cont;
    int *a=NULL;
    int *indice=NULL;
    double **tes;
    double **X;
    double **trai;
    int *k=NULL;
    
    X=calloc(n,sizeof(double *)); 
    tes=calloc(n,sizeof(double *));
    trai=calloc(n,sizeof(double *));
    k=calloc(n,sizeof(int));        
    indice=(int *)calloc(n,sizeof(int)); 

    indice=randperm(n);  
    for(i=0;i<n;i++){
          X[i]=x+indice[i]*p; 

          k[i]=X[i][p-1]; 
    }
    
   r=n/10;
   j=0;



    if(n%10==0){      
         for(i=0;i<10;i++){
             j=j+r;

             trai=training(X,j-r,j,n,p);  
             tes=test(X,j-r,r,p);         
             e=errores(tes,trai,k,n,p,m,r,j,rank,size);  
	     printf("\niteracion %d  PROCESADOR  %d error %d \n",i,rank,e);	    
             MPI_Reduce(&e,&par_e,1,MPI_INT,MPI_SUM,0,MPI_COMM_WORLD);
             err+=par_e;                               
        }

    

 else {       
           for(i=0;i<n%10;i++){
              j=j+r+1;
              trai=training(X,j-r-1,j,n,p);     
              tes=test(X,j-r-1,r+1,p);           
              e=errores(tes,trai,k,n,p,m,r+1,j,rank,size);  
	      printf("\niteracion %d  PROCESADOR  %d error %d \n",i,rank,e);	    
              MPI_Reduce(&e,&par_e,1,MPI_INT,MPI_SUM,0,MPI_COMM_WORLD);
              err+=e;                          
           }
           for(i=n%10;i<10;i++){
               j=j+r;
               trai=training(X,j-r,j,n,p);       
               tes=test(X,j-r,r,p);              

               e=errores(tes,trai,k,n,p,m,r,j,rank,size);  
	       printf("\niteracion %d  PROCESADOR  %d error %d \n",i,rank,e);	    
               MPI_Reduce(&e,&par_e,1,MPI_INT,MPI_SUM,0,MPI_COMM_WORLD);
               err+=e;                             
           }
    
      }
   return err;
   }

   */







int main(int argc, char * argv[]){
 
     int rank,size;

   
     MPI_Status status;
     MPI_Init(&argc,&argv);
     MPI_Comm_rank(MPI_COMM_WORLD,&rank);
     MPI_Comm_size(MPI_COMM_WORLD,&size);

  
if(rank==0)

{
    FILE *in;                /*se declara un apuntador de tipo FILE*/

    int n,m,p,r;
    int cont;
    int par_e=0,err=0,e=0;
    int parametro[4];
    int i,j=0,promedio;
    int *k;
    int *indice;
    int par_cross(double *,int,int,int,int,int);
    int par_estimated(double **,double **, int *,int, int, int ,int,int,int,int,int);    
    double time;
    double **X;
    double **f;
    double **trai;
    double **tes;
    double *x=NULL;    /*se declara apuntador de tipo double para leer los datos del archivo*/


    if(argc!=6){
       fprintf(stderr,"Uso de %s\n  nombre_del_archivo #_de_filas  #_de_columnas #_de_clases #_de_corridas_promedio\n",argv[0]);
       exit(1);
    }
    time=MPI_Wtime();
    n=atoi(argv[2]);            /*se convierte el segundo argumento a tipo entero*/
    p=atoi(argv[3]);            /*se convierte el tercer argumento a tipo entero*/
    m=atoi(argv[4]);            /*se convierte el cuarto argumento a tipo entero*/
    promedio = atoi(argv[5]);   /*se convierte el quinto argumento a tipo entero*/
    
    parametro[0]=n; 
    parametro[1]=p;
    parametro[2]=m;
    parametro[3]=promedio;
   
 
    MPI_Bcast(parametro,4,MPI_INT,0,MPI_COMM_WORLD);
    
    indice=calloc(n,sizeof(int));
    k=calloc(n,sizeof(int));
    x=calloc(n*p,sizeof(double));    
    tes=calloc(n,sizeof(double *)); 
    trai=calloc(n,sizeof(double *)); 
    f=calloc(m,sizeof(double *)); 
    X=calloc(n,sizeof(double *)); 
   
    in=fopen(argv[1],"r");        
    if(in==NULL){                
         printf("problemas con el archivo de salida");
         exit(1);
    }
    while (!feof(in)){   
             fscanf(in,"%lf",&x[j]);
             j++;
      }
  fclose(in);  
 
  /* MPI_Ssend(x,n*p,MPI_DOUBLE,1,0,MPI_COMM_WORLD);*/

  


   MPI_Bcast(x,n*p,MPI_DOUBLE,0,MPI_COMM_WORLD);
   indice=randperm(n); 
   MPI_Bcast(indice,n,MPI_INT,0,MPI_COMM_WORLD);
    
    for(i=0;i<n;i++){
          X[i]=x+indice[i]*p; 
	  /*  X[i]=x+i*p; se hace una copia del vector x a la matriz X*/
          k[i]=X[i][p-1];   
    }

   /*   par_e= par_cross(x,n,m,p,rank,size);*/
  
     r=n/10;
     j=0;


    if(n%10==0){      
         for(i=0;i<10;i++){
             j=j+r;

             trai=training(X,j-r,j,n,p);  
             tes=test(X,j-r,r,p);         
             e=errores(tes,trai,k,n,p,m,r,j,rank,size);  
	     printf("\niteracion %d  PROCESADOR  %d error %d \n",i,rank,e);	    
             MPI_Reduce(&e,&par_e,1,MPI_INT,MPI_SUM,0,MPI_COMM_WORLD);
             err+=par_e;                               
        }

    
    }
 else {       
           for(i=0;i<n%10;i++){
              j=j+r+1;
              trai=training(X,j-r-1,j,n,p);     
              tes=test(X,j-r-1,r+1,p);           
              e=errores(tes,trai,k,n,p,m,r+1,j,rank,size);  
	      printf("\niteracion %d  PROCESADOR  %d error %d \n",i,rank,e);	    
              MPI_Reduce(&e,&par_e,1,MPI_INT,MPI_SUM,0,MPI_COMM_WORLD);
              err+=par_e;                          
           }
           for(i=n%10;i<10;i++){
               j=j+r;
               trai=training(X,j-r,j,n,p);       
               tes=test(X,j-r,r,p);              

               e=errores(tes,trai,k,n,p,m,r,j,rank,size);  
	       printf("\niteracion %d  PROCESADOR  %d error %d \n",i,rank,e);	    
               MPI_Reduce(&e,&par_e,1,MPI_INT,MPI_SUM,0,MPI_COMM_WORLD);
               err+=par_e;                             
           }
    
      }

    time=MPI_Wtime()-time;
  printf("\nPROCESADOR  %d   ERROR  %f  PAR_ERROR %d TIME %lf\n",rank,(double)(err)/(double)(n*promedio),err,time);

  MPI_Finalize();

  }
  
 else{
 
  int i,j,r,e=0,par_e=0,err=0,temp[4];
  int par_cross(double *,int,int,int,int,int);
  int *indice;
  int *k;
  double *x=NULL;
  double *h;
  double **f;
  double **trai;
  double **training(double **,int,int,int,int);
  double **tes;
  double **test(double **,int,int,int);
  double **X;
  
     
  MPI_Bcast(temp,4,MPI_INT,0,MPI_COMM_WORLD);

 
  indice=calloc(temp[0],sizeof(int));
  k=calloc(temp[0],sizeof(int));
  tes=calloc(temp[0],sizeof(double *)); 
  trai=calloc(temp[0],sizeof(double *)); 
  x=calloc(temp[0]*temp[1],sizeof(double));
  X=calloc(temp[0],sizeof(double *));
  f=calloc(temp[2],sizeof(double *));
  h=calloc(temp[1],sizeof(double));   

 
  MPI_Bcast(x,temp[0]*temp[1],MPI_DOUBLE,0,MPI_COMM_WORLD);
  MPI_Bcast(indice,temp[0],MPI_INT,0,MPI_COMM_WORLD);
 
    for(i=0;i<temp[0];i++){
          X[i]=x+indice[i]*temp[1]; 
	  /*  X[i]=x+i*p; se hace una copia del vector x a la matriz X*/
          k[i]=X[i][temp[1]-1];   
    }

  r= temp[0]/10;
  j=0;






    if(temp[0]%10==0){      

         for(i=0;i<10;i++){
             j=j+r;
             trai=training(X,j-r,j,temp[0],temp[1]);  
             tes=test(X,j-r,r,temp[1]);         
       
	     e=errores(tes,trai,k,temp[0],temp[1],temp[2],r,j,rank,size);  

             printf("\niteracion %d  PROCESADOR  %d error %d \n",i,rank,e);	    
	     MPI_Reduce(&e,&par_e,1,MPI_INT,MPI_SUM,0,MPI_COMM_WORLD);
	
             err+=par_e;                               
         }
    }

 else {       
           for(i=0;i<temp[0]%10;i++){
              j=j+r+1;
              trai=training(X,j-r-1,j,temp[0],temp[1]);
              tes=test(X,j-r-1,r+1,temp[1]);           
              e=errores(tes,trai,k,temp[0],temp[1],temp[2],r+1,j,rank,size);
	      printf("\niteracion %d  PROCESADOR  %d error %d \n",i,rank,e);	    
              MPI_Reduce(&e,&par_e,1,MPI_INT,MPI_SUM,0,MPI_COMM_WORLD);
              err+=par_e;                          
           }
           for(i=temp[0]%10;i<10;i++){
               j=j+r;
               trai=training(X,j-r,j,temp[0],temp[1]);
               tes=test(X,j-r,r,temp[1]);              
               e=errores(tes,trai,k,temp[0],temp[1],temp[2],r,j,rank,size);  
              
	       printf("\niteracion %d  PROCESADOR  %d error %d \n",i,rank,e);	    
               MPI_Reduce(&e,&par_e,1,MPI_INT,MPI_SUM,0,MPI_COMM_WORLD);
               err+=par_e;                             
           }
    
      }

 MPI_Finalize();

}

 return 0;
  

 }












